"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TextUtility = /** @class */ (function () {
    function TextUtility() {
    }
    // tslint:disable-next-line:member-ordering
    TextUtility.getInstance = function () {
        if (!TextUtility.instance) {
            TextUtility.instance = new TextUtility();
        }
        return TextUtility.instance;
    };
    /**
     * Check for Empty string
     * @param value
     */
    TextUtility.prototype.isEmpty = function (value) {
        if (value === undefined || value === null || value.length === 0) {
            return true;
        }
        else {
            return false;
        }
    };
    /**
     * Allow only valid characters
     * @param e
     * @param dataObject
     */
    TextUtility.prototype.validInputChars = function (e, object) {
        if (object.type === "phone") {
            var allowedChars = /[0-9-/:.]+/g;
            if (!allowedChars.test(e.key)) {
                e.preventDefault();
            }
        }
        else if (object.type === "number") {
            var allowedChars = /[0-9]+/g;
            if (!allowedChars.test(e.key) || e.target.value > object.max) {
                e.preventDefault();
            }
        }
        else if (object.type !== "password") {
            var allowedChars = /[0-9a-zA-Z-/:.@ ']+/g;
            if (!allowedChars.test(e.key)) {
                e.preventDefault();
            }
        }
    };
    /**
     *
     * @param value Validate email address
     */
    TextUtility.prototype.isValidEmail = function (value) {
        var emailPattern = /(.+)@(.+){2,}\.(.+){2,}/;
        if (!emailPattern.test(value)) {
            return false;
        }
        else {
            return true;
        }
    };
    /**
     *
     * @param value Val
     */
    TextUtility.prototype.isValidPhoneNumber = function (value) {
        var phoneno = /^[\+]?[(]?[0-9]{3}[)]?[-\s\.]?[0-9]{3}[-\s\.]?[0-9]{4,6}$/im;
        if (value.match(phoneno)) {
            return true;
        }
        else {
            return false;
        }
    };
    TextUtility.prototype.isValidMacAddress = function (value) {
        var regexp = /^(([A-Fa-f0-9]{2}[:]){5}[A-Fa-f0-9]{2}[,]?)+$/i;
        if (regexp.test(value)) {
            return true;
        }
        else {
            return false;
        }
    };
    TextUtility.prototype.saveItemInLocal = function (key, value) {
        localStorage.setItem(key, value);
    };
    TextUtility.prototype.getItemFromLocal = function (key) {
        var value = localStorage.getItem(key);
        return value;
    };
    return TextUtility;
}());
exports.default = TextUtility;
//# sourceMappingURL=TextUtils.js.map