"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var React = require("react");
var react_select_1 = require("react-select");
require("../AgGridComponent.css");
var DropDownFilter = /** @class */ (function (_super) {
    __extends(DropDownFilter, _super);
    function DropDownFilter(props) {
        var _this = _super.call(this, props) || this;
        _this.valueChanged = function (event) {
            event === null ?
                _this.setState({
                    currentValue: "All",
                    selectedOption: "All"
                }, function () {
                    _this.props.onFloatingFilterChanged({ model: _this.buildModel() });
                })
                :
                    _this.setState({
                        currentValue: event.value,
                        selectedOption: event.value
                    }, function () {
                        _this.props.onFloatingFilterChanged({ model: _this.buildModel() });
                    });
        };
        _this.state = {
            selectedOption: 'All',
            currentValue: '',
            options: [],
            columnData: {},
            columnId: '',
            columnValues: '',
        };
        return _this;
    }
    DropDownFilter.prototype.buildModel = function () {
        if (this.state.currentValue === "All") {
            return null;
        }
        return {
            filterType: 'text',
            type: 'equals',
            filter: this.state.currentValue
        };
    };
    DropDownFilter.prototype.onParentModelChanged = function (parentModel) {
        this.setState({
            currentValue: !parentModel ? "All" : parentModel.filter.toLowerCase().split(' ').map(function (a) { return a.charAt(0).toUpperCase() + a.substr(1); }).join(' '),
            selectedOption: !parentModel ? "All" : parentModel.filter.toLowerCase().split(' ').map(function (a) { return a.charAt(0).toUpperCase() + a.substr(1); }).join(' ')
        });
    };
    DropDownFilter.prototype.componentDidMount = function () {
        this.getData();
    };
    DropDownFilter.prototype.getData = function () {
        var _this = this;
        this.setState({ columnValues: new Array('All'), columnId: this.props.column.colId }, function () {
            _this.props.api.forEachNode(function (node, index) {
                _this.state.columnValues.push(node.data[_this.state.columnId]);
                return _this.state.columnValues;
            });
            var colUniqueValues = _.uniq(_this.state.columnValues);
            var dropdownOptions = [];
            colUniqueValues.forEach(function (element) {
                var res = {
                    "value": element, "label": element
                };
                dropdownOptions.push(res);
            });
            _this.setState({ options: dropdownOptions });
        });
    };
    DropDownFilter.prototype.render = function () {
        var _this = this;
        var dot = function () { return ({
            fontSize: 22,
            paddingLeft: 14,
            color: 'white',
            marginTop: 18
        }); };
        // Styles applied to the dropdown React Select Filter
        var colourStyles = {
            control: function (styles) { return ({ backgroundColor: 'transparent', }); },
            option: function (styles, isFocused, isDisabled, isSelected) {
                return __assign({}, styles, { backgroundColor: isDisabled
                        ? null
                        : isSelected ? null : isFocused ? _this.props.column.colDef.color : null, color: 'white', height: 36, fontSize: 16, padding: 0, paddingLeft: 20, cursor: isDisabled ? 'not-allowed' : 'default' });
            },
            placeholder: function (styles) { return ({ color: 'white', paddingLeft: 14, fontSize: 22, paddingTop: 10 }); },
            dropdownIndicator: function (styles) { return ({ color: 'white', position: 'absolute', top: 20, right: -24 }); },
            singleValue: function (styles) { return (__assign({}, styles, dot())); }
        };
        return (React.createElement(react_select_1.default, { name: "form-field-name", classNamePrefix: "select", options: this.state.options, onChange: this.valueChanged, placeholder: this.state.selectedOption, styles: colourStyles, isSearchable: false, isDisabled: false }));
    };
    return DropDownFilter;
}(React.Component));
exports.default = DropDownFilter;
;
//# sourceMappingURL=dropDownFilter.js.map