"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
var React = require("react");
var react_dates_1 = require("react-dates");
// tslint:disable-next-line:no-submodule-imports
require("react-dates/initialize");
// tslint:disable-next-line:no-submodule-imports
require("react-dates/lib/css/_datepicker.css");
require("../AgGridComponent.css");
var InRangeDateFilter = /** @class */ (function (_super) {
    __extends(InRangeDateFilter, _super);
    function InRangeDateFilter(props) {
        var _this = _super.call(this, props) || this;
        _this.updateState = function (startDate, endDate) {
            _this.setState({
                startDate: startDate, endDate: endDate, cross: true
            }, function () {
                _this.props.onFloatingFilterChanged({ model: _this.buildModel() });
            });
        };
        _this.state = {
            cross: false,
            startDate: props.startDate === undefined ? undefined : moment(props.startDate),
            endDate: props.endDate === undefined ? undefined : moment(props.endDate),
            focusedInput: null,
        };
        _this.updateState = _this.updateState.bind(_this);
        _this.onClear = _this.onClear.bind(_this);
        return _this;
    }
    InRangeDateFilter.prototype.buildModel = function () {
        if (this.clear === true) {
            return null;
        }
        return {
            type: 'inRange',
            dateFrom: this.state.startDate === null ? this.state.endDate.format("YYYY-MM-DD") : this.state.startDate.format("YYYY-MM-DD"),
            dateTo: this.state.endDate === null ? this.state.startDate.format("YYYY-MM-DD") : this.state.endDate.format("YYYY-MM-DD")
        };
    };
    InRangeDateFilter.prototype.onParentModelChanged = function (parentModel) {
        this.clear = false;
    };
    InRangeDateFilter.prototype.onClear = function () {
        this.setState({
            startDate: null,
            endDate: null,
            cross: false
        });
        this.clear = true;
        this.props.onFloatingFilterChanged({ model: this.buildModel() });
    };
    InRangeDateFilter.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", { className: "table-column-daterangepicker" },
            React.createElement("span", null,
                React.createElement(react_dates_1.DateRangePicker, { customArrowIcon: React.createElement("i", null, "-"), showDefaultInputIcon: !this.state.cross, inputIconPosition: 'after', noBorder: true, hideKeyboardShortcutsPanel: true, startDateId: "startDateId", endDateId: "endDateId", numberOfMonths: 2, minimumNights: 0, small: true, readOnly: true, 
                    // tslint:disable-next-line:jsx-no-lambda
                    isOutsideRange: function () { return false; }, startDate: this.state.startDate, endDate: this.state.endDate, 
                    // tslint:disable-next-line:jsx-no-lambda
                    onDatesChange: function (_a) {
                        var startDate = _a.startDate, endDate = _a.endDate;
                        _this.updateState(startDate, endDate);
                    }, focusedInput: this.state.focusedInput, 
                    // tslint:disable-next-line:jsx-no-lambda
                    onFocusChange: function (focusedInput) {
                        _this.setState({ focusedInput: focusedInput });
                    } })),
            this.state.cross && this.state.focusedInput !== "" ? (React.createElement("span", { onClick: this.onClear },
                React.createElement("i", { className: "fa fa-times dateCross", "aria-hidden": "true" }))) : "",
            React.createElement("div", { className: "hairlineDateRange" })));
    };
    return InRangeDateFilter;
}(React.Component));
exports.default = InRangeDateFilter;
;
//# sourceMappingURL=inRangeDateFilter.js.map