"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
require("../AgGridComponent.css");
var TextSearchFilter = /** @class */ (function (_super) {
    __extends(TextSearchFilter, _super);
    function TextSearchFilter(props) {
        var _this = _super.call(this, props) || this;
        _this.valueChanged = function (event) {
            if (event.target.value !== "") {
                _this.setState({
                    currentValue: event.target.value,
                    cross: true
                }, function () {
                    _this.props.onFloatingFilterChanged({ model: _this.buildModel() });
                });
            }
            if (event.target.value === "") {
                _this.setState({
                    currentValue: "",
                    cross: false
                }, function () {
                    _this.props.onFloatingFilterChanged({ model: _this.buildModel() });
                });
            }
        };
        _this.valueCleared = function () {
            _this.props.onFloatingFilterChanged({ model: _this.buildModel() });
        };
        _this.state = {
            selectedOption: 'All',
            currentValue: '',
            options: '',
            columnData: {},
            columnId: '',
            columnValues: '',
            cross: props.currentValue !== "",
            value: props.value,
        };
        _this.valueChanged = _this.valueChanged.bind(_this);
        _this.onClear = _this.onClear.bind(_this);
        return _this;
    }
    TextSearchFilter.prototype.componentWillReceiveProps = function (nextProps) {
        this.setState({ value: nextProps.value });
    };
    TextSearchFilter.prototype.buildModel = function () {
        if (this.state.currentValue === "") {
            return null;
        }
        return {
            filterType: 'text',
            type: 'contains',
            filter: this.state.currentValue
        };
    };
    TextSearchFilter.prototype.onParentModelChanged = function (parentModel) {
        this.setState({
            currentValue: !parentModel ? null : parentModel.filter
        });
        if (!parentModel || parentModel.filter === "") {
            this.setState({ cross: false });
        }
    };
    TextSearchFilter.prototype.onClear = function () {
        var _this = this;
        this.setState({ currentValue: "", cross: false }, function () {
            _this.valueCleared();
        });
    };
    TextSearchFilter.prototype.render = function () {
        return (React.createElement("div", { className: "table-column-searchbar" },
            React.createElement(react_bootstrap_1.Row, null,
                React.createElement(react_bootstrap_1.Col, { xs: 12 },
                    React.createElement("input", { type: "text", value: this.state.currentValue, onChange: this.valueChanged, className: "inputSearch" }),
                    this.state.cross && this.state.currentValue !== "" ? (React.createElement("span", { onClick: this.onClear },
                        React.createElement("i", { className: "fa fa-times searchicon", "aria-hidden": "true" }))) : (React.createElement("span", null,
                        React.createElement("i", { className: "fa fa-search searchicon", "aria-hidden": "true" }))))),
            React.createElement("div", { className: "hairlineTextSearch" })));
    };
    return TextSearchFilter;
}(React.Component));
exports.default = TextSearchFilter;
;
//# sourceMappingURL=textSearchFilter.js.map