"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ag_grid_react_1 = require("ag-grid-react");
// tslint:disable-next-line:no-submodule-imports
require("ag-grid/dist/styles/ag-grid.css");
// tslint:disable-next-line:no-submodule-imports
require("ag-grid/dist/styles/ag-theme-material.css");
var moment = require("moment");
var React = require("react");
var Loader_1 = require("../Loader");
require("./AgGridComponent.css");
var capitalizeFirstCellRenderer_1 = require("./Cell Renderer/capitalizeFirstCellRenderer");
var DateCellRenderer_1 = require("./Cell Renderer/DateCellRenderer");
var DateTimeCellRenderer_1 = require("./Cell Renderer/DateTimeCellRenderer");
var dollarCellRenderer_1 = require("./Cell Renderer/dollarCellRenderer");
var LinkCellRenderer_1 = require("./Cell Renderer/LinkCellRenderer");
var PhaseCellRenderer_1 = require("./Cell Renderer/PhaseCellRenderer");
var dropDownFilter_1 = require("./Filters/dropDownFilter");
var inRangeDateFilter_1 = require("./Filters/inRangeDateFilter");
var textSearchFilter_1 = require("./Filters/textSearchFilter");
var AgGridComponent = /** @class */ (function (_super) {
    __extends(AgGridComponent, _super);
    function AgGridComponent(props) {
        var _this = _super.call(this, props) || this;
        // Grid Events we're listening to
        _this.onGridReady = function (params) {
            _this.setState({
                api: params.api
            });
        };
        _this.onRowSelected = function (event) {
            _this.props.rowOnClick(_this.state.api.getSelectedRows()[0], true);
            _this.state.api.deselectAll();
        };
        _this.state = {
            color: '',
            api: undefined,
            rowData: _this.props.rowData,
            tableTemplate: '',
            gridOptions: {
                enableFilter: true, floatingFiltersHeight: _this.props.floatingFiltersHeight, headerHeight: _this.props.headerHeight, enableColResize: true, rowHeight: _this.props.rowHeight,
                defaultColDef: {
                    headerComponentParams: {
                        template: '<div class="ag-cell-label-container" role="presentation">' +
                            '  <div ref="eLabel" class="ag-header-cell-label" role="presentation">' +
                            '    <span ref="eText" class="ag-header-cell-text" role="columnheader"></span>' +
                            '    <span ref="eSortOrder" class="ag-header-icon ag-sort-order" ></span>' +
                            '    <span ref="eSortAsc" class="ag-header-icon ag-sort-ascending-icon" ></span>' +
                            '    <span ref="eSortDesc" class="ag-header-icon ag-sort-descending-icon" ></span>' +
                            '    </div>' +
                            '    </div>'
                    },
                    suppressMenu: true,
                    editable: true,
                    overlayNoRowsTemplate: "<span style=\"padding: 10px; border: 2px solid #444; background: lightgoldenrodyellow;\">This is a custom 'no rows' overlay</span>",
                    // Specify the order of the Sorting sequence. Do not change until need to change the sequence
                    sortingOrder: ["desc", "asc"],
                    // change the delay of the values filtered through text search by changing debounceMs (pass value in Ms)
                    floatingFilterComponentParams: {
                        suppressFilterButton: true,
                        debounceMs: 0
                    }
                },
                // define a column type (you can define as many as you like)
                columnTypes: {
                    "noFilterColumn": { suppressFilter: true, editable: false },
                    "textFilterColumn": { floatingFilterComponent: "TextSearchFloatingFilter", floatingFilterComponentParams: {
                            suppressFilterButton: true
                        }, editable: false },
                    "dropDownFilterColumn": { floatingFilterComponent: "DropDownFloatingFilter", floatingFilterComponentParams: {
                            suppressFilterButton: true
                        }, editable: false },
                    "dateFilterColumn": { filter: "agDateColumnFilter", floatingFilterComponent: "InRangeDateFloatingFilter", floatingFilterComponentParams: {
                            suppressFilterButton: true
                        }, filterParams: { inRangeInclusive: true, comparator: function (filterLocalDateAtMidnight, cellValue) {
                                var cellValueDate = cellValue ? moment(cellValue).format('DD/MM/YYYY') : null;
                                if (cellValueDate === null) {
                                    return -1;
                                }
                                var dateParts = cellValueDate.split("/");
                                var cellDate = new Date(Number(dateParts[2]), Number(dateParts[1]) - 1, Number(dateParts[0]));
                                if (filterLocalDateAtMidnight.getTime() === cellDate.getTime()) {
                                    return 0;
                                }
                                if (cellDate < filterLocalDateAtMidnight) {
                                    return -1;
                                }
                                if (cellDate > filterLocalDateAtMidnight) {
                                    return 1;
                                }
                                return 0;
                            }
                        }, cellRenderer: "DatecellRenderer", editable: false },
                    "dropDownDateFilter": { cellRenderer: "DatecellRenderer", floatingFilterComponent: "DropDownFloatingFilter", floatingFilterComponentParams: {
                            suppressFilterButton: true
                        }, editable: false
                    },
                    "lastColumn": { suppressResize: true, suppressMovable: true }
                },
            },
            rowSelection: "multiple",
            icons: {
                sortAscending: '<i class="fas fa-caret-up" style="color: white"></i>',
                sortDescending: '<i class="fas fa-caret-down" style="color: white"></i>'
            },
            frameworkComponents: {
                DropDownFloatingFilter: dropDownFilter_1.default, InRangeDateFloatingFilter: inRangeDateFilter_1.default, TextSearchFloatingFilter: textSearchFilter_1.default,
                DatecellRenderer: DateCellRenderer_1.default, LinkcellRenderer: LinkCellRenderer_1.default, DateTimecellRenderer: DateTimeCellRenderer_1.default, DollarCell: dollarCellRenderer_1.default,
                CapitalCell: capitalizeFirstCellRenderer_1.default, PhaseCell: PhaseCellRenderer_1.default
            }
        };
        return _this;
    }
    AgGridComponent.prototype.onGridSizeChanged = function (params) {
        params.api.sizeColumnsToFit();
    };
    // get cellvalue
    AgGridComponent.prototype.cellClicked = function (event) {
        // on Cell clicked
    };
    AgGridComponent.prototype.export = function (name) {
        var params = {
            allColumns: true,
            fileName: name
        };
        this.state.api.csvCreator.exportDataAsCsv(params);
    };
    AgGridComponent.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.rowData !== nextProps.rowData) {
            if (this.state.api !== undefined) {
                this.state.api.refreshHeader();
            }
            this.setState({ rowData: nextProps.rowData });
        }
    };
    AgGridComponent.prototype.render = function () {
        if (this.state.api !== undefined) {
            this.state.api.sizeColumnsToFit();
        }
        return (React.createElement("div", { className: "ag-theme-material" }, JSON.stringify(this.props.rowData) === '{}' || this.props.rowData === undefined ?
            React.createElement(Loader_1.default, null)
            : React.createElement(ag_grid_react_1.AgGridReact
            // listening for events
            , { 
                // listening for events
                onGridReady: this.onGridReady, onRowClicked: this.onRowSelected, rowSelection: this.state.rowSelection, 
                // tslint:disable-next-line:jsx-no-bind
                // onSelectionChanged={this.onSelectionChanged.bind(this)}
                // binding to an object property
                icons: this.state.icons, 
                // binding to array properties
                rowData: this.state.rowData, rowClassRules: this.state.rowClassRules, 
                // boolean properties must be provided for Grid Level Properties
                enableColResize: true, colResizeDefault: "shift", enableSorting: true, enableFilter: true, floatingFilter: true, suppressHorizontalScroll: true, suppressMovableColumns: true, suppressContextMenu: true, 
                // suppress removing of column when it leaves the grid
                suppressDragLeaveHidesColumns: true, 
                // setting grid wide date component
                // dateComponentFramework={DateComponent}
                // setting default column properties
                columnDefs: this.props.columnDefs, gridOptions: this.state.gridOptions, onCellClicked: this.cellClicked, overlayNoRowsTemplate: this.state.overlayNoRowsTemplate, frameworkComponents: this.state.frameworkComponents, onGridSizeChanged: this.onGridSizeChanged })));
    };
    return AgGridComponent;
}(React.Component));
exports.default = AgGridComponent;
//# sourceMappingURL=index.js.map