"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var moment = require("moment");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var react_datepicker_1 = require("react-datepicker");
var react_tippy_1 = require("react-tippy");
// tslint:disable-next-line:no-submodule-imports
require("react-tippy/dist/tippy.css");
require("./DatePickerField.css");
var DatepickerField = /** @class */ (function (_super) {
    __extends(DatepickerField, _super);
    function DatepickerField(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            startDate: (_this.props.InputProps.value !== "") ? moment(_this.props.InputProps.value) : null,
            show: false,
        };
        _this.handleChange = _this.handleChange.bind(_this);
        _this.onFocus = _this.onFocus.bind(_this);
        _this.onBlur = _this.onBlur.bind(_this);
        return _this;
    }
    DatepickerField.prototype.componentWillReceiveProps = function (nexProps) {
        if (nexProps.InputProps.value === "") {
            this.setState({
                startDate: null
            });
        }
        else {
            this.setState({
                startDate: moment(nexProps.InputProps.value)
            });
        }
    };
    DatepickerField.prototype.onFocus = function () {
        this.setState({
            show: true,
        });
    };
    DatepickerField.prototype.onBlur = function () {
        this.setState({
            show: false,
        });
    };
    DatepickerField.prototype.handleChange = function (date, event) {
        // const allowedChars = /[0-9/]+/g;
        // if (!allowedChars.test(event.key)) {
        //     event.preventDefault();
        // }
        this.setState({
            startDate: date
        });
        if (date && date._d !== undefined) {
            var selectedDate = void 0;
            if (this.props.InputProps.name.includes("OpenDate")) {
                selectedDate = moment(date._d).format("YYYY-MM-DDT00:00:00");
            }
            if (this.props.InputProps.name.includes("CloseDate")) {
                selectedDate = moment(date._d).format("YYYY-MM-DDT23:59:59");
            }
            this.props.InputProps.onChange(this.props.InputProps.name, selectedDate);
        }
        localStorage.setItem("SaveClicked", "false");
    };
    DatepickerField.prototype.render = function () {
        var _a = this.props, InputProps = _a.InputProps, disabled = _a.disabled, halfRow = _a.halfRow;
        var _b = this.state, startDate = _b.startDate, show = _b.show;
        var theme = disabled ? "disabled-input" : (InputProps.error && InputProps.touched) ? "datepicker-input error" : "datepicker-input";
        return (React.createElement("div", { className: "input-container" },
            React.createElement(react_bootstrap_1.Row, { className: halfRow ? "halfRow" : "" },
                React.createElement(react_bootstrap_1.Col, { xs: 4, className: "field-title" }, InputProps.title),
                React.createElement(react_bootstrap_1.Col, { xs: halfRow ? 4 : 8 },
                    React.createElement("div", { className: disabled ? "datePickerLogo disabledDatePickerLogo" : "datePickerLogo" },
                        React.createElement(react_datepicker_1.default, { id: InputProps.name, name: InputProps.name, selected: startDate, onChange: this.handleChange, disabled: disabled, className: theme, onFocus: this.onFocus, onBlur: this.onBlur, readOnly: true }),
                        React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faCalendarAlt }))),
                React.createElement(react_tippy_1.Tooltip, { title: InputProps.error, position: "right", open: InputProps.error && InputProps.touched && show ? true : false, arrow: true, size: "big", sticky: true, className: "formTooltip" }))));
    };
    return DatepickerField;
}(React.Component));
var FormikDatePicker = function (_a) {
    var field = __rest(_a.field, []), props = __rest(_a, ["field"]);
    var error = props.errors[field.name];
    var touched = props.touched[field.name];
    var InputProps = {
        name: field.name,
        error: error,
        touched: touched,
        value: props.value ? props.value : field.value,
        onChange: props.setFieldValue,
        title: props.formTitles[field.name],
    };
    return (React.createElement(DatepickerField, __assign({ InputProps: InputProps }, props)));
};
exports.default = FormikDatePicker;
//# sourceMappingURL=FormikDatePicker.js.map