"use strict";
/*tslint:disable*/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
require("react-datepicker/dist/react-datepicker.css");
var react_datepicker_1 = require("react-datepicker");
require("./DatePickerField.css");
var TextUtils_1 = require("../../../Utilities/TextUtils");
var react_tippy_1 = require("react-tippy");
// tslint:disable-next-line:no-submodule-imports
require("react-tippy/dist/tippy.css");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var DatePickerField = /** @class */ (function (_super) {
    __extends(DatePickerField, _super);
    function DatePickerField(props) {
        var _this = _super.call(this, props) || this;
        _this.onDateSelect = function (date, event) {
            // const allowedChars = /[0-9/]+/g;
            // if (!allowedChars.test(event.key)) {
            //     event.preventDefault();
            // }
            _this.setState({
                object: __assign({}, _this.state.object, { selectedDate: date, showErrorBox: false, showTooltip: false })
            });
            _this.props.onDateSelect(date);
        };
        _this.onFocus = function () {
            _this.setState({
                object: __assign({}, _this.state.object, { showTooltip: _this.state.object.showErrorBox })
            });
        };
        /**
        * On Focus out, hide showErrorBox
        */
        _this.onBlur = function () {
            _this.setState({
                object: __assign({}, _this.state.object, { showErrorBox: false, showTooltip: false })
            });
        };
        _this.state = {
            object: props,
        };
        return _this;
    }
    DatePickerField.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.state.object !== nextProps) {
            this.setState({
                object: nextProps
            });
        }
    };
    DatePickerField.prototype.render = function () {
        var _a = this.state.object, fieldName = _a.fieldName, required = _a.required, minDateSelected = _a.minDateSelected, selectedDate = _a.selectedDate, showErrorBox = _a.showErrorBox, showTooltip = _a.showTooltip, errorMessage = _a.errorMessage, _b = _a.editable, editable = _b === void 0 ? true : _b, hideFieldName = _a.hideFieldName;
        return (React.createElement("div", null,
            !hideFieldName ?
                React.createElement("div", { className: "labelName" },
                    fieldName,
                    required ? React.createElement("span", { className: "red-asterisk" }, "*") : "") : "",
            React.createElement(react_tippy_1.Tooltip, { title: TextUtils_1.default.getInstance().isEmpty(errorMessage) ? "INPUT_ERR_MESSAGE" : errorMessage, open: showTooltip, position: "right", arrow: true, size: "big", trigger: "manual" },
                "   ",
                React.createElement("div", { className: !editable ? "datePickerLogo disabledDatePickerLogo" : "datePickerLogo" },
                    React.createElement(react_datepicker_1.default, __assign({}, (!TextUtils_1.default.getInstance().isEmpty(minDateSelected) ? { minDate: minDateSelected } : {}), (!TextUtils_1.default.getInstance().isEmpty(selectedDate) ? { selected: selectedDate } : {}), { onChange: this.onDateSelect, onFocus: this.onFocus, onBlur: this.onBlur }, (!editable) ? { readOnly: true } : {}, { className: showErrorBox ? "input_field_error" : !editable ? "datepicker_field_noedit" : "datepicker_field" })),
                    " ",
                    React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faCalendarAlt }))),
            React.createElement("br", null)));
    };
    return DatePickerField;
}(React.Component));
exports.default = DatePickerField;
//# sourceMappingURL=index.js.map