import * as React from 'react';
import FormFields from '../../../types/FormFields';
import './DropdownField.css';
interface Props extends FormFields {
    /**
     * Key value options for Select dropdown
     */
    dropdownOptions?: any;
    onSelect?: any;
}
interface Methods {
    onSelect(e: any): any;
}
declare module "react-select" {
    interface ReactSelectProps<TValue = OptionValues> {
        inputValue?: string;
        isClearable?: boolean;
        styles?: {};
        isSearchable?: boolean;
        isDisabled: boolean;
    }
}
declare class DropdownField extends React.Component<Props, any> implements Methods {
    constructor(props: Props);
    /**
     * Update the states with new props only if newprops is changed
     * @param nextProps newly updated props
     */
    componentWillReceiveProps(nextProps: Props): void;
    /**
     * Handle onchange of input text
     * @param e Event param
     */
    onSelect: (selectedOption: any) => void;
    render(): JSX.Element;
}
export default DropdownField;
