"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_select_1 = require("react-select");
require("./DropdownField.css");
var DropdownField = /** @class */ (function (_super) {
    __extends(DropdownField, _super);
    function DropdownField(props) {
        var _this = _super.call(this, props) || this;
        /**
         * Handle onchange of input text
         * @param e Event param
         */
        _this.onSelect = function (selectedOption) {
            _this.setState({
                object: __assign({}, _this.state.object, { fieldValue: selectedOption })
            });
            _this.props.onSelect(selectedOption);
        };
        _this.state = {
            object: props
        };
        return _this;
    }
    /**
     * Update the states with new props only if newprops is changed
     * @param nextProps newly updated props
     */
    DropdownField.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps !== this.state) {
            this.setState({
                object: nextProps
            });
        }
    };
    DropdownField.prototype.render = function () {
        var _a = this.state.object, fieldName = _a.fieldName, showErrorBox = _a.showErrorBox, identifier = _a.identifier, hideFieldName = _a.hideFieldName, required = _a.required, dropdownOptions = _a.dropdownOptions, fieldValue = _a.fieldValue, disabled = _a.disabled;
        return (React.createElement("div", { className: identifier },
            !hideFieldName ?
                React.createElement("div", { className: "labelName" },
                    fieldName,
                    required ? React.createElement("span", { className: "red-asterisk" }, "*") : "") : "",
            React.createElement("div", null,
                React.createElement(react_select_1.default, { className: showErrorBox ? "input_field_error" : "dropdownField", classNamePrefix: "dropDownTextField", name: identifier, onChange: this.onSelect, options: dropdownOptions, isDisabled: disabled, value: fieldValue, placeholder: fieldValue })),
            React.createElement("br", null)));
    };
    return DropdownField;
}(React.Component));
exports.default = DropdownField;
//# sourceMappingURL=index.js.map