"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
// tslint:disable-next-line:no-submodule-imports
var react_tippy_1 = require("react-tippy");
// tslint:disable-next-line:no-submodule-imports
require("react-tippy/dist/tippy.css");
var TextUtils_1 = require("../../../Utilities/TextUtils");
require("./InputField.css");
var InputField = /** @class */ (function (_super) {
    __extends(InputField, _super);
    function InputField(props) {
        var _this = _super.call(this, props) || this;
        /**
         * Handle onchange of input text
         * @param e Event param
         */
        _this.onChange = function (e) {
            _this.setState({
                object: __assign({}, _this.state.object, { fieldValue: e.target.value, showErrorBox: false, showTooltip: false })
            });
            _this.props.onChange(e);
        };
        /**
         * On focus set showTooltip if errorbox is true
         * @param e Event param
         */
        _this.onFocus = function () {
            _this.setState({
                object: __assign({}, _this.state.object, { showTooltip: _this.state.object.showErrorBox })
            });
        };
        /**
         * On Focus out, hide showErrorBox
         */
        _this.onBlur = function () {
            _this.setState({
                object: __assign({}, _this.state.object, { showErrorBox: false, showTooltip: false })
            });
        };
        /**
         * Allow keys of only specific characters
         */
        _this.onKeyPress = function (e) {
            TextUtils_1.default.getInstance().validInputChars(e, _this.state.object);
        };
        _this.state = {
            object: _this.props
        };
        return _this;
    }
    /**
     * Update the states with new props only if newprops is changed
     * @param nextProps newly updated props
     */
    InputField.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps !== this.state) {
            this.setState({
                object: nextProps
            });
        }
    };
    InputField.prototype.render = function () {
        var _a = this.state.object, fieldValue = _a.fieldValue, fieldName = _a.fieldName, showErrorBox = _a.showErrorBox, identifier = _a.identifier, hideFieldName = _a.hideFieldName, required = _a.required, disabled = _a.disabled, maxLength = _a.maxLength, showTooltip = _a.showTooltip, errorMessage = _a.errorMessage, _b = _a.editable, editable = _b === void 0 ? true : _b, type = _a.type, placeholder = _a.placeholder, _c = _a.tooltipDirection, tooltipDirection = _c === void 0 ? "right" : _c, min = _a.min, max = _a.max;
        return (React.createElement("div", { className: identifier },
            !hideFieldName ?
                React.createElement("div", { className: "labelName" },
                    fieldName,
                    required ? React.createElement("span", { className: "red-asterisk" }, "*") : "") : "",
            React.createElement(react_tippy_1.Tooltip, { title: TextUtils_1.default.getInstance().isEmpty(errorMessage) ? "INPUT_ERR_MESSAGE" : errorMessage, open: showTooltip, position: tooltipDirection, arrow: true, size: "big", trigger: "manual" },
                React.createElement("input", __assign({ className: showErrorBox ? "input_field_error" : editable ? identifier : "input_field_noedit", disabled: disabled, maxLength: maxLength, onChange: this.onChange, onFocus: this.onFocus, onBlur: this.onBlur, onKeyPress: this.onKeyPress, name: this.props.name, value: fieldValue, placeholder: placeholder, type: type, min: min, max: max }, (!editable) ? { readOnly: true } : {}))),
            React.createElement("br", null)));
    };
    return InputField;
}(React.Component));
exports.default = InputField;
//# sourceMappingURL=index.js.map