"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var react_tippy_1 = require("react-tippy");
// tslint:disable-next-line:no-submodule-imports
require("react-tippy/dist/tippy.css");
require("./TextArea.css");
var TextareaField = /** @class */ (function (_super) {
    __extends(TextareaField, _super);
    function TextareaField(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            show: false,
        };
        _this.onFocus = _this.onFocus.bind(_this);
        _this.onBlur = _this.onBlur.bind(_this);
        return _this;
    }
    TextareaField.prototype.onFocus = function () {
        this.setState({
            show: true,
        });
    };
    TextareaField.prototype.onBlur = function () {
        this.setState({
            show: false,
        });
    };
    TextareaField.prototype.render = function () {
        var _a = this.props, InputProps = _a.InputProps, disabled = _a.disabled, halfRow = _a.halfRow, maxLength = _a.maxLength;
        var show = this.state.show;
        var theme = disabled ? "disabled-textarea" : (InputProps.error && InputProps.touched) ? "textarea-input error" : "textarea-input";
        return (React.createElement("div", { className: "input-container" },
            React.createElement(react_bootstrap_1.Row, { className: halfRow ? "halfRow" : "" },
                React.createElement(react_bootstrap_1.Col, { xs: 4, className: "field-title" }, InputProps.title),
                React.createElement(react_bootstrap_1.Col, { xs: 8 },
                    React.createElement("textarea", { id: InputProps.name, name: InputProps.name, value: InputProps.value, onChange: InputProps.onChange, className: theme, disabled: disabled, onFocus: this.onFocus, onBlur: this.onBlur, maxLength: maxLength })),
                React.createElement(react_tippy_1.Tooltip, { title: InputProps.error, position: "right", open: InputProps.error && InputProps.touched && show ? true : false, arrow: true, size: "big", sticky: true, className: "formTooltip" }))));
    };
    return TextareaField;
}(React.Component));
var FormikTextArea = function (_a) {
    var field = __rest(_a.field, []), props = __rest(_a, ["field"]);
    var error = props.errors[field.name];
    var touched = props.touched[field.name];
    // tslint:disable-next-line:one-variable-per-declaration
    var InputProps = {
        name: field.name,
        error: error,
        touched: touched,
        value: props.value ? props.value : field.value,
        onChange: props.handleChange,
        title: props.formTitles[field.name],
    };
    return (React.createElement(TextareaField, __assign({ InputProps: InputProps }, props)));
};
exports.default = FormikTextArea;
//# sourceMappingURL=FormikTextArea.js.map