import * as React from 'react';
import './TextArea.css';
import FormFields from '../../../types/FormFields';
interface TextAreaProps extends FormFields {
    /**
     * No of Rows
     */
    rows?: number;
    maxLength?: number;
    value?: any;
    onChange?: any;
    name?: any;
}
declare class TextArea extends React.Component<TextAreaProps, any> {
    constructor(props: TextAreaProps);
    handleChange: (event: any) => void;
    /**
      * Update the states with new props only if newprops is changed
      * @param nextProps newly updated props
      */
    componentWillReceiveProps(nextProps: TextAreaProps): void;
    /**
     * On focus set showTooltip if errorbox is true
     * @param e Event param
     */
    onFocus: () => any;
    /**
     * On Focus out, hide showErrorBox
     */
    onBlur: () => any;
    render(): JSX.Element;
}
export default TextArea;
