"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable*/
var React = require("react");
require("./TextArea.css");
var react_tippy_1 = require("react-tippy");
var TextUtils_1 = require("../../../Utilities/TextUtils");
var TextArea = /** @class */ (function (_super) {
    __extends(TextArea, _super);
    function TextArea(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (event) {
            _this.setState({
                object: __assign({}, _this.state.object, { fieldValue: event.target.value, showErrorBox: false, showTooltip: false })
            });
            _this.props.onChange(event);
        };
        /**
         * On focus set showTooltip if errorbox is true
         * @param e Event param
         */
        _this.onFocus = function () {
            _this.setState({
                object: __assign({}, _this.state.object, { showTooltip: _this.state.object.showErrorBox })
            });
        };
        /**
         * On Focus out, hide showErrorBox
         */
        _this.onBlur = function () {
            _this.setState({
                object: __assign({}, _this.state.object, { showErrorBox: false, showTooltip: false })
            });
        };
        _this.state = {
            object: _this.props
        };
        return _this;
    }
    /**
      * Update the states with new props only if newprops is changed
      * @param nextProps newly updated props
      */
    TextArea.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps !== this.state) {
            this.setState({
                object: nextProps
            });
        }
    };
    TextArea.prototype.render = function () {
        console.log(this.props);
        var _a = this.state.object, identifier = _a.identifier, _b = _a.editable, editable = _b === void 0 ? true : _b, errorMessage = _a.errorMessage, showTooltip = _a.showTooltip, showErrorBox = _a.showErrorBox, maxLength = _a.maxLength;
        return (React.createElement("div", { className: identifier },
            React.createElement(react_tippy_1.Tooltip, { title: TextUtils_1.default.getInstance().isEmpty(errorMessage) ? "INPUT_ERR_MESSAGE" : errorMessage, open: showTooltip, position: "right", arrow: true, size: "big", trigger: "manual" },
                React.createElement("textarea", { className: showErrorBox ? "textArea_field_error" : !editable ? "textArea_noedit" : "textArea", onChange: this.handleChange, name: this.props.name, onFocus: this.onFocus, onBlur: this.onBlur, value: this.state.object.value, maxLength: maxLength }))));
    };
    return TextArea;
}(React.Component));
exports.default = TextArea;
//# sourceMappingURL=index.js.map