"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_datepicker_1 = require("react-datepicker");
// tslint:disable-next-line:no-submodule-imports
require("react-datepicker/dist/react-datepicker.css");
var TextUtils_1 = require("../../../Utilities/TextUtils");
require("./TimePickerField.css");
var react_tippy_1 = require("react-tippy");
// tslint:disable-next-line:no-submodule-imports
require("react-tippy/dist/tippy.css");
var TimePickerField = /** @class */ (function (_super) {
    __extends(TimePickerField, _super);
    function TimePickerField(props) {
        var _this = _super.call(this, props) || this;
        _this.onTimeSelect = function (time) {
            _this.setState({
                object: __assign({}, _this.state.object, { selectedTime: time, showErrorBox: false, showTooltip: false })
            });
        };
        _this.onFocus = function () {
            _this.setState({
                object: __assign({}, _this.state.object, { showTooltip: _this.state.object.showErrorBox })
            });
        };
        /**
         * On Focus out, hide showErrorBox
         */
        _this.onBlur = function () {
            _this.setState({
                object: __assign({}, _this.state.object, { showErrorBox: false, showTooltip: false })
            });
        };
        _this.state = {
            object: props
        };
        return _this;
    }
    TimePickerField.prototype.render = function () {
        var _a = this.state.object, fieldName = _a.fieldName, required = _a.required, selectedTime = _a.selectedTime, showErrorBox = _a.showErrorBox, _b = _a.editable, editable = _b === void 0 ? true : _b, showTooltip = _a.showTooltip, errorMessage = _a.errorMessage;
        return (React.createElement("div", null,
            React.createElement("div", { className: "labelName" },
                fieldName,
                required ? React.createElement("span", { className: "red-asterisk" }, "*") : ""),
            React.createElement(react_tippy_1.Tooltip, { title: TextUtils_1.default.getInstance().isEmpty(errorMessage) ? "INPUT_ERR_MESSAGE" : errorMessage, open: showTooltip, position: "left", arrow: true, size: "big", trigger: "manual" },
                React.createElement(react_datepicker_1.default, __assign({}, (!TextUtils_1.default.getInstance().isEmpty(selectedTime) ? { selected: selectedTime } : {}), { onChange: this.onTimeSelect, onFocus: this.onFocus, onBlur: this.onBlur, className: showErrorBox ? "input_field_error" : !editable ? "timepicker_field_noedit" : "timepicker_field", showTimeSelect: true, showTimeSelectOnly: true, timeIntervals: 30, dateFormat: "LT" }))),
            React.createElement("br", null)));
    };
    return TimePickerField;
}(React.Component));
exports.default = TimePickerField;
//# sourceMappingURL=index.js.map