"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var React = require("react");
var react_responsive_modal_1 = require("react-responsive-modal");
require("./ImageContainer.css");
var ImageContainer = /** @class */ (function (_super) {
    __extends(ImageContainer, _super);
    function ImageContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.onOpenModalVideo = function (videoURL) {
            _this.setState({ openVideo: true, videoUrl: videoURL });
        };
        _this.onCloseModalVideo = function () {
            _this.setState({ openVideo: false });
        };
        _this.onOpenModalImage = function (imageURL) {
            _this.setState({ openImage: true, imageUrl: imageURL });
        };
        _this.onCloseModalImage = function () {
            _this.setState({ openImage: false });
        };
        _this.state = {
            openVideo: false,
            openImage: false,
            videoUrl: "",
            imageUrl: ""
        };
        return _this;
    }
    ImageContainer.prototype.imageModal = function () {
        return (React.createElement("img", { src: this.state.imageUrl, className: this.props.type }));
    };
    ImageContainer.prototype.renderImage = function () {
        var _this = this;
        var _a = this.props, value = _a.value, type = _a.type;
        return _.map(value, function (link) {
            if (link.PostVideoURL !== "") {
                return (React.createElement("a", null,
                    React.createElement("img", { src: link.MediaURL, className: type }),
                    React.createElement("i", { className: "fas fa-play", onClick: function () { return _this.onOpenModalVideo(link.PostVideoURL); } }),
                    React.createElement(react_responsive_modal_1.default, { open: _this.state.openVideo, onClose: _this.onCloseModalVideo, center: true, closeOnEsc: true },
                        React.createElement("video", { width: "800", controls: true },
                            React.createElement("source", { src: _this.state.videoUrl })))));
            }
            else {
                return (React.createElement("a", { className: "imageModal" },
                    React.createElement("img", { src: link.MediaURL, className: type, onClick: function () { return _this.onOpenModalImage(link.MediaURL); } }),
                    React.createElement(react_responsive_modal_1.default, { open: _this.state.openImage, onClose: _this.onCloseModalImage, center: true, closeOnEsc: true },
                        React.createElement("img", { className: "modalImage", src: _this.state.imageUrl }))));
            }
        });
    };
    ImageContainer.prototype.render = function () {
        var _a = this.props, title = _a.title, className = _a.className;
        return (React.createElement("div", { className: "col-sm-12 text-center" },
            React.createElement("div", { className: className }, title),
            this.renderImage()));
    };
    return ImageContainer;
}(React.Component));
exports.default = ImageContainer;
//# sourceMappingURL=index.js.map