"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var moment = require("moment");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
// import ImageBox from '../ImageBox/ImageContainer';
// import FormFields from '../../types/FormFields';
require("./LabelText.css");
var LabelText = /** @class */ (function (_super) {
    __extends(LabelText, _super);
    function LabelText(props) {
        var _this = _super.call(this, props) || this;
        _this.renderLayout = function () {
            var _a = _this.props, type = _a.type, title = _a.title, value = _a.value, phaseRowData = _a.phaseRowData;
            switch (type) {
                case 'twoRowInput':
                    return (React.createElement(react_bootstrap_1.Col, { xs: 12, className: "label-style" },
                        React.createElement("div", { className: "label-grey col-xs-12" }, title),
                        React.createElement("div", { className: "label-black col-xs-12" }, value)));
                    break;
                case 'twoRowInput2':
                    return (React.createElement(react_bootstrap_1.Col, { xs: 6, className: "label-style" },
                        React.createElement("div", { className: "label-grey col-xs-12" }, title),
                        React.createElement("div", { className: "label-black col-xs-12" }, value)));
                    break;
                case 'MultiLineInput':
                    return (React.createElement(react_bootstrap_1.Col, { xs: 12, className: "label-style" },
                        React.createElement("div", { className: "label-grey col-xs-12" }, title),
                        _this.renderCheckMultiLine(value)));
                    break;
                case 'OneRowInput':
                    return (React.createElement(react_bootstrap_1.Col, { xs: 12, className: "label-style" },
                        React.createElement("div", { className: "label-grey col-xs-3" }, title),
                        React.createElement("div", { className: "label-black col-xs-9" }, value)));
                    break;
                case 'OneRowInputMaxField':
                    return (React.createElement(react_bootstrap_1.Col, { xs: 12, className: "label-style" },
                        React.createElement("div", { className: "label-grey col-xs-9" }, title),
                        React.createElement("div", { className: "label-black col-xs-3" }, value)));
                    break;
                case 'dateInput':
                    return (React.createElement(react_bootstrap_1.Col, { xs: 6, className: "label-style" },
                        React.createElement("div", { className: "label-grey col-xs-5" }, title),
                        React.createElement("div", { className: "label-black col-xs-7" }, moment(value).format("MM/DD/YYYY h:mm A"))));
                    break;
                case 'phaseTextInput':
                    if (phaseRowData !== undefined && phaseRowData.length !== 0) {
                        return (React.createElement(react_bootstrap_1.Col, { xs: 6, className: "label-style" },
                            React.createElement("div", { className: "label-grey col-xs-5" }, title),
                            React.createElement("div", { className: "label-black col-xs-7 phaseValue" },
                                React.createElement("span", { id: "P0", className: phaseRowData.PhaseMasterID === 0 ? "highLight" : phaseRowData.PhaseMasterID0 === false ? "disabledPhase" : "phaseNum", onClick: phaseRowData.PhaseMasterID0 && _this.handleClick }, "P0"),
                                React.createElement("i", { className: "fa fa-caret-right" }),
                                React.createElement("span", { id: "P1", className: phaseRowData.PhaseMasterID === 1 ? "highLight" : phaseRowData.PhaseMasterID1 === false ? "disabledPhase" : "phaseNum", onClick: phaseRowData.PhaseMasterID1 && _this.handleClick }, "P1"),
                                React.createElement("i", { className: "fa fa-caret-right" }),
                                React.createElement("span", { id: "P2", className: phaseRowData.PhaseMasterID === 2 ? "highLight" : phaseRowData.PhaseMasterID2 === false ? "disabledPhase" : "phaseNum", onClick: phaseRowData.PhaseMasterID2 && _this.handleClick }, "P2"),
                                React.createElement("i", { className: "fa fa-caret-right" }),
                                React.createElement("span", { id: "P3", className: phaseRowData.PhaseMasterID === 3 ? "highLight" : phaseRowData.PhaseMasterID3 === false ? "disabledPhase" : "phaseNum", onClick: phaseRowData.PhaseMasterID3 && _this.handleClick }, "P3"))));
                    }
                    ;
                default:
                    return (React.createElement(react_bootstrap_1.Col, { xs: 6, className: "label-style" },
                        React.createElement("div", { className: "label-grey col-xs-5" }, title),
                        React.createElement("div", { className: "label-black col-xs-7" }, value)));
                    break;
            }
            return;
        };
        _this.handleClick = _this.handleClick.bind(_this);
        return _this;
    }
    LabelText.prototype.handleClick = function (event) {
        this.props.handlePhaseClick(event.currentTarget.id);
    };
    LabelText.prototype.renderCheckMultiLine = function (value) {
        return _.map(value, function (text) {
            return React.createElement("div", { className: "label-black col-xs-12" }, text);
        });
    };
    LabelText.prototype.render = function () {
        return (React.createElement("div", null, this.renderLayout()));
    };
    return LabelText;
}(React.Component));
exports.default = LabelText;
//# sourceMappingURL=LabelText.js.map