"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var React = require("react");
require("./sidebarItems.css");
var SidebarItems = /** @class */ (function (_super) {
    __extends(SidebarItems, _super);
    function SidebarItems(props) {
        var _this = _super.call(this, props) || this;
        _this.renderList = _this.renderList.bind(_this);
        _this.handleOnClick = _this.handleOnClick.bind(_this);
        _this.handleOptionOnClick = _this.handleOptionOnClick.bind(_this);
        return _this;
    }
    SidebarItems.prototype.handleOnClick = function (event) {
        this.props.handleClick(event);
    };
    SidebarItems.prototype.handleOptionOnClick = function (event) {
        this.props.handleOptionClick(event);
    };
    SidebarItems.prototype.renderOption = function (options) {
        var _this = this;
        return _.map(options, function (item) {
            var optionClassName = "itemOption";
            if (options[0] === item && _this.props.selectedOption === undefined) {
                optionClassName = "itemOptionWhite";
            }
            for (var j = 0; j <= options.length - 1; j++) {
                if (item === options[j] && _this.props.selectedOption === options[j]) {
                    optionClassName = "itemOptionWhite";
                }
            }
            return (React.createElement("div", { className: optionClassName, onClick: _this.handleOptionOnClick, id: item, key: item }, item));
        });
    };
    SidebarItems.prototype.renderList = function () {
        var _this = this;
        var _a = this.props, menuItems = _a.menuItems, selectedTable = _a.selectedTable;
        return _.map(menuItems, function (item) {
            var itemClassName = "item";
            var arrowClassName = "sideBarArrow";
            var showOption = false;
            for (var i = 0; i <= menuItems.length - 1; i++) {
                if (item === menuItems[i] && selectedTable === menuItems[i].name) {
                    itemClassName = "item whiteItem";
                    arrowClassName = "sideBarArrowWhite";
                    if (menuItems[i].options !== null) {
                        showOption = true;
                    }
                }
            }
            return (React.createElement("div", { key: item.key },
                React.createElement("div", { className: "menuItems", onClick: _this.handleOnClick, id: item.name },
                    React.createElement("div", { className: itemClassName }, item.name),
                    React.createElement("div", { className: arrowClassName },
                        React.createElement("i", { className: showOption ? "fa fa-lg fa-angle-down pull-right" : "fa fa-lg fa-angle-right pull-right" }))),
                React.createElement("div", null, showOption && _this.renderOption(item.options))));
        });
    };
    SidebarItems.prototype.render = function () {
        return (React.createElement("div", null, this.renderList()));
    };
    return SidebarItems;
}(React.Component));
exports.default = SidebarItems;
//# sourceMappingURL=index.js.map