import * as React from "react";
import FormFields from "../../types/FormFields";
import './KeyValueContainer.css';
interface KeyValueDataFields extends FormFields {
    /**
     * Type of Value field = Input / Label / Drop Down / Date Picker etc...
     */
    type: number;
    /**
     * Orientation of Key Value pair
     */
    layout_type: string;
    /**
     * Is the value field editable
     */
    edit: boolean;
    /**
     * Data value for this key value pair
     */
    data?: any;
    onChange?: any;
    name?: any;
    hideFieldName?: any;
    field?: any;
    onDateSelect?: any;
    minDate?: any;
    options?: any;
    onSelect?: any;
}
declare class KeyValueContainer extends React.Component<KeyValueDataFields, any> {
    renderValueBasedOnType(type: number): any;
    getTextArea: () => JSX.Element;
    render(): JSX.Element;
    renderLayout: () => JSX.Element;
}
export default KeyValueContainer;
