"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
var React = require("react");
var react_bootstrap_1 = require("react-bootstrap");
var components_1 = require("../../components");
var DatePicker_1 = require("../../components/FormComponents/DatePicker");
var Dropdown_1 = require("../../components/FormComponents/Dropdown");
var InputField_1 = require("../../components/FormComponents/InputField");
var ListItems_1 = require("../../components/FormComponents/ListItems");
var ListCheckboxes_1 = require("../../components/FormComponents/ListItems/ListCheckboxes");
var TextArea_1 = require("../../components/FormComponents/TextArea");
var TimePicker_1 = require("../../components/FormComponents/TimePicker");
var LabelField_1 = require("../../components/Label/LabelField");
var AppConstants_1 = require("../../constants/AppConstants");
require("./KeyValueContainer.css");
var options = {
    "values": [
        { value: 'one', label: 'One' },
        { value: 'two', label: 'Two' },
        { value: 'three', label: 'Three' },
        { value: 'four', label: 'Four' },
    ]
};
var KeyValueContainer = /** @class */ (function (_super) {
    __extends(KeyValueContainer, _super);
    function KeyValueContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getTextArea = function () {
            if (_this.props.edit) {
                return React.createElement(TextArea_1.default, __assign({}, _this.props, { value: _this.props.fieldValue, editable: _this.props.edit, onChange: _this.props.onChange, name: name, hideFieldName: _this.props.hideFieldName }));
            }
            else {
                return React.createElement(LabelField_1.default, { fieldName: _this.props.fieldValue, type: "label-black" });
            }
        };
        _this.renderLayout = function () {
            var _a = _this.props, type = _a.type, layout_type = _a.layout_type;
            switch (layout_type) {
                case 'twoRowInput':
                    return (React.createElement(react_bootstrap_1.Col, { xs: 12, className: "label-style" },
                        React.createElement("div", { className: "col-xs-12" },
                            React.createElement(LabelField_1.default, __assign({}, _this.props, { fieldName: _this.props.fieldName, type: "label-grey" }))),
                        React.createElement("div", { className: "col-xs-12" }, _this.renderValueBasedOnType(type))));
                    break;
                case 'OneRowInput':
                    return (React.createElement(react_bootstrap_1.Col, { xs: 12, className: "label-style" },
                        React.createElement("div", { className: "col-xs-3" },
                            React.createElement(LabelField_1.default, __assign({}, _this.props, { fieldName: _this.props.fieldName, type: "label-grey" }))),
                        React.createElement("div", { className: "col-xs-9" }, _this.renderValueBasedOnType(type))));
                case 'TextOnly':
                    return (React.createElement(react_bootstrap_1.Col, { xs: 12, className: "label-style" }, _this.renderValueBasedOnType(type)));
                default:
                    return (React.createElement(react_bootstrap_1.Col, { xs: 6, className: "label-style" },
                        React.createElement("div", { className: "col-xs-5" },
                            React.createElement(LabelField_1.default, __assign({}, _this.props, { fieldName: _this.props.fieldName, type: "label-grey" }))),
                        React.createElement("div", { className: "col-xs-7" }, _this.renderValueBasedOnType(type))));
                    break;
            }
        };
        return _this;
    }
    KeyValueContainer.prototype.renderValueBasedOnType = function (type) {
        var _a = this.props, name = _a.name, fieldValue = _a.fieldValue, edit = _a.edit;
        switch (type) {
            case AppConstants_1.TYPE_LABEL:
                // tslint:disable-next-line:no-unused-expression
                return React.createElement(InputField_1.default, __assign({}, this.props, { name: name, fieldValue: fieldValue, editable: edit, className: "label-black", onChange: this.props.onChange, hideFieldName: this.props.hideFieldName }));
            case AppConstants_1.TYPE_INPUT:
                return React.createElement(InputField_1.default, __assign({}, this.props, { fieldValue: this.props.fieldValue }));
            case AppConstants_1.TYPE_DATE_PICKER:
                return React.createElement(DatePicker_1.default, __assign({}, this.props, { identifier: "date", className: "datepicker", selectedDate: components_1.TextUtility.getInstance().isEmpty(fieldValue) ? "" : moment(fieldValue), editable: edit, onDateSelect: this.props.onDateSelect }));
            case AppConstants_1.TYPE_TIME_PICKER:
                return React.createElement(TimePicker_1.default, __assign({}, this.props, { identifier: "date", className: "datepicker", selectedTime: moment(fieldValue).format("H"), editable: edit }));
            case AppConstants_1.TYPE_IMAGE:
            //   <ImageContainer  className="large-rec-image" value="http://thewowstyle.com/wp-content/uploads/2015/03/Desktop-Wallpaper-HD2.jpg"  />
            case AppConstants_1.TYPE_TEXTAREA:
                return this.getTextArea();
            case AppConstants_1.TYPE_DROPDOWN:
                return React.createElement(Dropdown_1.default, __assign({}, this.props, { dropdownOptions: this.props.options, fieldValue: fieldValue, onSelect: this.props.onSelect }));
            case AppConstants_1.TYPE_LIST:
                return this.props.edit ?
                    React.createElement(ListCheckboxes_1.default, { listItems: options.values }) :
                    React.createElement(ListItems_1.default, { listItems: options.values });
        }
    };
    KeyValueContainer.prototype.render = function () {
        return (React.createElement("div", null, this.renderLayout()));
    };
    return KeyValueContainer;
}(React.Component));
exports.default = KeyValueContainer;
//# sourceMappingURL=KeyValueContainer.js.map