export default interface FormFields {
    /**
   *
   * max length of the field
   */
    maxLength?: number;
    /**
     * This field is for giving title to component
     */
    fieldName?: string;
    /**
     * A unique id/name to component
     */
    identifier?: string;
    /**
     * Classname to component or to it's parent div
     */
    className?: string;
    /**
     * To show red border when error
     */
    showErrorBox?: boolean;
    /**
     * Actual value for the field
     */
    fieldValue?: string;
    /**
     * To hide/show title
     */
    hideFieldName?: boolean;
    /**
     * Whether the field is necessary
     */
    required?: boolean;
    /**
     * whether the field is enabled/disabled
     */
    disabled?: boolean;
    /**
     * the message to display in tooltip when error
     */
    errorMessage?: string;
    /**
     * to hide/show tooltip
     */
    showTooltip?: boolean;
    /**
     * This field specifies whether the field is editable or not
     */
    editable?: boolean;
    /**
     * To add Place Holder
     */
    placeholder?: string;
}
